//void generateDataPoint()
//{
//  float radY = 0.0, radM = 0.0, r = 0.0;
//  println("total length", checkouts.length);
//  for (int i = 0; i < checkouts.length; i++)
//  {  

//    println("itemtypes", checkouts[i].size());
//    println("MovieName", checkouts[i].get(0).second);
//    color c = elementDetermine(checkouts[i].get(0).second);
//    MovieName name = checkouts[i].get(0).second;

//    for (int k = 0; k < checkouts[i].size(); k++)
//    {
//      int[] checkoutsYearly = checkouts[i].get(k).third;
//      int years = checkoutsYearly.length;
//      DataPoint dataset[] = new DataPoint[years];
//      radY = k * TWO_PI / checkouts[i].size();
//      for (int j = 0; j < years; j++)
//      {
//        radM =(j + 1) * (float) PI / (years + 1);
//        r =  map(checkoutsYearly[j], minCheckouts, maxCheckouts, 0, 2000);
//        // r = checkoutsYearly[j];
//        // radius / (MovieName.values().length - 1) * (findReleasedYear(name) - 1991);
//        float size = map(checkoutsYearly[j], minCheckouts, maxCheckouts, 0, 300);
//        dataset[j] = new DataPoint(name, findReleasedYear(name), r*sin(radY)*sin(radM), r*cos(radM), r*sin(radM)*cos(radY), size, c);
//        // dataset[j].printPoint();
//      }
//      allPoints[i].add(dataset);
//    }
//  }
//}

void generateDataPoint()
{
  float radY = 0.0, radM = 0.0, r = 0.0;
  println("total length", checkouts.length);
  for (int i = 0; i < checkouts.length; i++)
  {  

    println("itemtypes", checkouts[i].size());
    println("MovieName", checkouts[i].get(0).second);
    // println("color", c);
    MovieName name = checkouts[i].get(0).second;
    println("r", r);
    for (int k = 0; k < checkouts[i].size(); k++)
    {
      if(checkouts[i].size() <= 2)
      {
        if(k == 0) radY = random(0, TWO_PI);
        if(k == 1) radY = random(0, TWO_PI);
      }
      else
        radY = k * TWO_PI / checkouts[i].size();
      color c = elementDetermine(checkouts[i].get(k).first);
      int[] checkoutsYearly = checkouts[i].get(k).third;
      int years = checkoutsYearly.length;
      DataPoint dataset[] = new DataPoint[years];
      for (int j = 0; j < years; j++)
      {
          //radY = random(0, TWO_PI);
          //radM = random(0, PI);
          r = map(totalCheckoutsYearly[i], minCheckouts, maxCheckouts, 1, 150) +  map(checkoutsYearly[j], 0, 1000, 0, 100);
          // radY = k * TWO_PI / checkouts[i].size();
          // radY =  random(0, TWO_PI);//checkoutsYearly[j] * (TWO_PI / totalCheckoutsYearly[i]);
          radM = (j + 1) * (PI / (years + 1));
        // radius / (MovieName.values().length - 1) * (findReleasedYear(name) - 1991);
        float size = map(checkoutsYearly[j], 0, 1000, 5, 20);
        dataset[j] = new DataPoint(name, findReleasedYear(name), r*sin(radY)*sin(radM), r*cos(radM), r*sin(radM)*cos(radY), size, c);
        // dataset[j].printPoint();
      }
      allPoints[i].add(dataset);
    }
  }
}

void generateMesh()
{

  // Queue<Ptpair> queue = new PriorityQueue<Ptpair>(10, new ComparetorByDist());
  for (int index = 0; index < allPoints.length; index++)
  {
    float size = map(totalCheckoutsYearly[index], minCheckouts, maxCheckouts, 0, 100);
    if(allPoints[index].size() == 1)
    {
      for (int j = 0; j < allPoints[index].get(0).length - 1; j++)
      {
        PVector p1 = new PVector(allPoints[index].get(0)[j].x, allPoints[index].get(0)[j].y, allPoints[index].get(0)[j].z);
        PVector p2 = new PVector(allPoints[index].get(0)[j + 1].x, allPoints[index].get(0)[j + 1].y, allPoints[index].get(0)[j + 1].z);
        allLines[index].add(new Ptpair(p1, p2, 0));
      }
    }
    for (int i = 0; i < allPoints[index].size(); i++)
    {  
      // noFill();
      for (int j = 0; j < allPoints[index].get(i).length; j++)
      {
        PVector p1 = new PVector(allPoints[index].get(i)[j].x, allPoints[index].get(i)[j].y, allPoints[index].get(i)[j].z);
        Queue<Ptpair> queue = new PriorityQueue<Ptpair>(5, comparator);
        for (int m = i + 1; m < allPoints[index].size(); m++)
        {  
          for (int n = j + 1; n < allPoints[index].get(m).length; n++)
          {
            PVector p2 = new PVector(allPoints[index].get(m)[n].x, allPoints[index].get(m)[n].y, allPoints[index].get(m)[n].z);
            Ptpair temp = new Ptpair(p1, p2, p1.dist(p2));
            // temp.printPair();
            if (temp.dist < size)
            {
              if (queue.size() < 5)
              {
                queue.add(temp);
              } else
              {
                Ptpair top = queue.peek();
                if (top.dist > temp.dist)
                {
                  queue.poll();
                  queue.add(temp);
                }
              }
            }
          }
        }
        for (Ptpair item : queue) {
          allLines[index].add(item);
          // item.printPair();
        }
      }
    }

    println("allLines size", allLines.length);
  }
}

void generateWrapping()
{
  for (int i = 0; i < allPoints.length; i++)
  {
    // PVector[] pts = new PVector[allPoints[i].size() * allPoints[i].get(0).length];
    println("i:", i);
    for (int j = 0; j < allPoints[i].size(); j++)
    {
      println("name:", allPoints[i].get(j)[0].name);
      for (int k = 0; k < allPoints[i].get(j).length; k++)
      { 
        PVector pts = new PVector(allPoints[i].get(j)[k].x, allPoints[i].get(j)[k].y, allPoints[i].get(j)[k].z);
        wrap[i].addPt(pts);
        print("(", pts.x, pts.y, pts.z, ")");
      }
    }
  }
}


//void generateSkeleton()
//{
//  // println("all Points length", allPoints.length);
//  for (int i = 0; i < allPoints.length; i++)
//  {
//    // PVector[] pts = new PVector[allPoints[i].size() * allPoints[i].get(0).length];
//    println("i:", i);
//    println("name:", allPoints[i].get(0)[0].name);
//    ArrayList<PVector> pts = new ArrayList();
//    for (int j = 0; j < allPoints[i].size(); j++)
//    {
//      for (int k = 0; k < allPoints[i].get(j).length; k++)
//      { 
//        PVector temp = new PVector(allPoints[i].get(j)[k].x, allPoints[i].get(j)[k].y, allPoints[i].get(j)[k].z);
//        pts.add(temp);
//        print("(", temp.x, temp.y, temp.z, ")");
//      }
//    }
//    println();
//  }
//}