public class Triplet<T, U, V> {

    private final T first;
    private final U second;
    private final V third;

    public Triplet(T first, U second, V third) {
        this.first = first;
        this.second = second;
        this.third = third;
    }

    public T getFirst() { return first; }
    public U getSecond() { return second; }
    public V getThird() { return third; }
}

enum Itemtype
{
  acdvd, accd, acbk, acvhs, NONE;
}

enum MovieName
{
  ReservoirDogs, PulpFiction, JackieBrown, KillBill1, KillBill2, DeathProof, InglouriousBasterds, DjangoUnchained, HatefulEight, NONE;
}

public class DataPoint
{
  public float x, y, z, angle, r, size;
  public int checkoutYear;
  public MovieName name;
  public color c;
  
  DataPoint(MovieName name, int checkoutYear, float x, float y, float z, float size, color c)
  {
    this.name = name;
    this.checkoutYear = checkoutYear;
    this.x = x;
    this.y = y;
    this.z = z;
    this.size = size;
    this.c = c;
  }
  
  void printPoint()
  {
    println("name", name, "data year:", this.checkoutYear, "x, y, z:", this.x, this.y, this.z, "size", this.size, "color:", this.c);
  }
}

public class Ptpair
{
  PVector p1, p2;
  float dist;
  
  Ptpair(PVector p1, PVector p2, float dist)
  {
    this.p1 = p1;
    this.p2 = p2;
    this.dist = dist;
  }
  
  void printPair()
  {
    println("p1:(", this.p1.x,this.p1.y,this.p1.z, ") ", "p2:(", this.p2.x, this.p2.y, this.p2.z, ") ", "dist", dist);
  }
}


public class ComparetorByDist implements Comparator<Ptpair> {  
  
    public int compare(Ptpair p1, Ptpair p2) {  
        //compare by number 
        int result= p2.dist > p1.dist ? 1 : -1; 
        return (result);  
    }
}